diff -purN a/board/omap1510inn/platform.S b/board/omap1510inn/platform.S
--- a/board/omap1510inn/platform.S	2003-08-29 17:00:46.000000000 -0500
+++ b/board/omap1510inn/platform.S	2004-08-30 16:06:19.311904262 -0500
@@ -159,8 +159,15 @@ lock_end:
 	 */
 	mov r0, #0x10000000                 /* Load physical SDRAM base. */
 	mov r1, pc                          /* Get current execution location. */
-	cmp r1, r0                          /* Compare. */
-	bge skip_sdram                      /* Skip over EMIF-fast initialization if running from SDRAM. */
+	/* Zero all but top 6 bits of PC, as they alone detect whether an 
+	 * address is in the range 0x1000:0000-0x13ff:ffff, the 64M sized
+	 * valid range for SDRAM on the OMAP 1510/5910.
+	 */
+	and r1, r1, #0xfc000000
+	cmp r1, r0			/* Compare. */
+	beq skip_sdram			/* Skip over EMIF-fast initialization
+					 * if running from SDRAM.
+					 */
 
 	/*
 	 * Delay for SDRAM initialization.
diff -purN a/CHANGELOG b/CHANGELOG
--- a/CHANGELOG	2004-08-28 17:45:57.000000000 -0500
+++ b/CHANGELOG	2004-08-30 16:19:51.424947285 -0500
@@ -2,6 +2,11 @@
 Changes since U-Boot 1.1.1:
 ======================================================================
 
+* Patch by Michael Bendzick, 30 Aug 2004:
+  - Improve platform.S code for omap1510inn that detects whether code
+    is running from SDRAM or not.  Patch allows SDRAM to be configured
+    if code is running out of SRAM at 0x20000000.
+
 * Add support for IDS "NC650" board
 
 * Add automatic update support for LWMON board
